-- Average Enjoyer ^ω^ Lampovo Project
-- vk.com/lampovofs

licensePlatesStandalone = {}
licensePlatesStandalone.modDir = g_currentModDirectory

LicensePlateManager.loadMapData = Utils.overwrittenFunction(LicensePlateManager.loadMapData, function (self, superFunc, xmlFile, missionInfo, baseDirectory)
    LicensePlateManager:superClass().loadMapData(self, xmlFile, missionInfo, baseDirectory)

    LicensePlateManager.createLicensePlateXMLSchema()

    local filename = getXMLString(xmlFile, "map.licensePlates#filename")
    if filename ~= nil then
        self.xmlFilename = Utils.getFilename('data/licensePlates.xml', licensePlatesStandalone.modDir)
        self.licensePlateXML = XMLFile.load("mapLicensePlates", self.xmlFilename, LicensePlateManager.xmlSchema)
        if self.licensePlateXML ~= nil then
            self.xmlReferences = 0
            self:loadLicensePlatesFromXML(self.licensePlateXML, licensePlatesStandalone.modDir)

            if self.licensePlateXML ~= nil and self.xmlReferences == 0 then
                self.licensePlateXML:delete()
                self.licensePlateXML = nil
            end
        end
    end

    return true
end)

LicensePlateDialog.updateVariations = Utils.overwrittenFunction(LicensePlateDialog.updateVariations, function (self, superFunc)
    local texts = {}

    local typeMapping = {
        [1] = 1, [2] = 1, [3] = 1, 
        [4] = 2, [5] = 2, 
        [6] = 3, [7] = 3, [8] = 3, [9] = 3, 
        [10] = 4, [11] = 4, [12] = 4, [13] = 4, 
        [14] = 5, [15] = 5, [16] = 5, 
        [17] = 6, [18] = 6, [19] = 6, [20] = 6, 
        [21] = 7, [22] = 7, [23] = 7, 
        [24] = 8, [25] = 8, 
        [26] = 9, [27] = 9, 
        [28] = 10, [29] = 10, 
        [30] = 11, [31] = 11, [32] = 11, [33] = 11, 
        [34] = 12, [35] = 12, [36] = 12, 
        [37] = 13, [38] = 13, [39] = 13, [40] = 13, 
        [41] = 14, [42] = 14, [43] = 14, 
        [44] = 15, [45] = 15, [46] = 15, [47] = 15, 
        [48] = 16, [49] = 16, [50] = 16, 
    }

    for i = 1, #self.licensePlate.variations do
        local typeIndex = typeMapping[i] or i

        local typeText = string.format(g_i18n:getText("ui_licensePlateTypeItem"), typeIndex) .. " " .. g_i18n:getText("ui_licensePlateType" .. i)
        table.insert(texts, typeText)
    end

    self.typeOption:setTexts(texts)
    self.typeOption:setState(self.currentVariation)
end)

LicensePlate.setVariation = Utils.overwrittenFunction(LicensePlate.setVariation, function (self, superFunc, variationIndex)
    local variation = self.variations[variationIndex]
    if variation ~= nil then
        local oldVariation = self.variations[self.variationIndex]
        for i=1, #oldVariation.values do
            local value = oldVariation.values[i]
            if not value.isStatic then
                for j=1, getNumOfChildren(value.node) do
                    delete(getChildAt(value.node, j - 1))
                end
            end
        end

        self.variationIndex = variationIndex

        local oldVariations = {17, 18, 19, 20, 21, 22, 23, 44, 45, 46, 47, 48, 49, 50}

        local function isVariationInList(variationIndex, variationList)
            for _, value in ipairs(variationList) do
                if value == variationIndex then
                    return true
                end
            end
            return false
        end

        if isVariationInList(variationIndex, oldVariations) then
            colorIndex = 2
        else
            colorIndex = 1
        end

        for i=1, #variation.values do
            local value = variation.values[i]

            if not value.isStatic then
                value.characterLine = CharacterLine.new(value.node, self.font, 1)
                value.characterLine:setSizeAndScale(self.fontSize, self.fontScaleX, self.fontScaleY)
                value.characterLine:setTextAlignment(RenderText.ALIGN_CENTER)
                value.characterLine:setTextVerticalAlignment(RenderText.VERTICAL_ALIGN_MIDDLE)
            end
        end

        for i=1, #variation.materials do
            local material = variation.materials[i]
            material:apply(self.node)
        end

        local colors, _ = self.manager:getAvailableColors()
        local textColor = colors[colorIndex]
        self:setColor(textColor.color[1], textColor.color[2], textColor.color[3])
    end
end)

LicensePlate.setColorIndex = Utils.overwrittenFunction(LicensePlate.setColorIndex, function (self, superFunc, colorIndex)
end)